## mednafen 0.8.D.3

=== src/nes/sound/fir/Makefile ===
CC	= gcc
%.h:	%.coef
	cat $< | ./toh > $@ || true

all:            floogie ntsc.h pal.h

floogie:	toh.o
		gcc -o toh toh.o

## mednafen 0.8.D

=== debian/changelog ===
mednafen (0.8.D-1) unstable; urgency=low

  * New upstream version.
  * Mention homepage.
  * Update debian/copyright.
  * Register documentation with doc-base.

 -- Stephen Kitt <steve@sk2.org>  Mon, 31 May 2010 06:49:35 +0200

mednafen (0.8.C-1) unstable; urgency=low

  * New maintainer (closes: #510531).
  * New upstream version (closes: #506462):
    - 10-gcc4.4-const-char.patch: removed, merged upstream.
  * Standards-Version 3.8.4, no change required.
  * Provide nes-emulator (closes: #485974).

 -- Stephen Kitt <steve@sk2.org>  Thu, 04 Feb 2010 14:50:12 +0100

mednafen (0.8.9-1.1) unstable; urgency=low

  [Jari Aalto]
  * Non-maintainer upload.
  * Update to packaging format "3.0 (quilt)" due to patch.
  * debian/patches
    - (number 10): Add patch to fix GCC 4.4
      invalid conversion from const char* to char*.
      (RC bug FTBFS serious; Closes: #560474).
  * debian/source/format
     - New file.

 -- Jari Aalto <jari.aalto@cante.net>  Sat, 09 Jan 2010 21:00:28 +0200

mednafen (0.8.9-1) unstable; urgency=low

  * New upstream version.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Mon, 09 Jun 2008 16:38:25 -0400

mednafen (0.8.8-1) unstable; urgency=low

  * New upstream version.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Thu, 03 Apr 2008 10:43:51 -0400

mednafen (0.8.7-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Explicitly include required headers to fix FTBFS with gcc-4.3.  (Closes:
    #417446)

 -- James Vega <jamessan@debian.org>  Sun, 09 Mar 2008 17:10:00 -0400

mednafen (0.8.7-1) unstable; urgency=low

  * New upstream version. 

 -- Ryan Schultz <schultz.ryan@gmail.com>  Sun, 06 Jan 2008 11:58:07 -0500

mednafen (0.8.6-1) unstable; urgency=low

  * New upstream version.
  * Closes: #417446. Upstream fixed this in a different way than the patch.
  * Update Debian packaging to compat = 5.
  * Update x-dev depend to x11proto-core-dev.
  * Add copyright information for galois.
  * Add copyright information for Debian packaging.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Fri, 04 Jan 2008 14:48:16 -0500

mednafen (0.8.5-1) unstable; urgency=low

  * New upstream version. 
  * Closes: #449877. Patch from Raphael Geissert <atomo64@gmail.com>.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Sun, 16 Dec 2007 18:50:43 -0500

mednafen (0.8.4-rc3-1) unstable; urgency=low

  * New upstream version.
  * Closes: #447551

 -- Ryan Schultz <schultz.ryan@gmail.com>  Mon, 22 Oct 2007 22:27:12 -0400

mednafen (0.8.1-1) unstable; urgency=low

  * New upstream version.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Mon, 22 Oct 2007 22:26:23 -0400

mednafen (0.7.2-1) unstable; urgency=low

  * New upstream version. 

 -- Ryan Schultz <schultz.ryan@gmail.com>  Thu, 22 Feb 2007 16:45:25 -0500

mednafen (0.7.1-1) unstable; urgency=low

  * New upstream release. 

 -- Ryan Schultz <schultz.ryan@gmail.com>  Sun, 24 Dec 2006 13:19:55 -0500

mednafen (0.7.0-1) unstable; urgency=low

  * New upstream version.
  * Updated copyright.
  * Added build rules for ALSA on *BSDs.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Sat, 23 Dec 2006 12:34:18 -0500

mednafen (0.6.5-1) unstable; urgency=low

  * New upstream version. Closes: #385807

 -- Ryan Schultz <schultz.ryan@gmail.com>  Wed,  6 Sep 2006 21:04:34 -0400

mednafen (0.6.4-1) unstable; urgency=low

  * New upstream version.
  * Update copyrights.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Mon, 28 Aug 2006 13:32:02 -0400

mednafen (0.6.3-1) unstable; urgency=low

  * New upstream version. 

 -- Ryan Schultz <schultz.ryan@gmail.com>  Thu, 10 Aug 2006 14:45:16 -0400

mednafen (0.6.2-1) unstable; urgency=low

  * New upstream version. 

 -- Ryan Schultz <schultz.ryan@gmail.com>  Wed, 21 Jun 2006 16:26:18 -0400

mednafen (0.6.1-1) unstable; urgency=low

  * New upstream version. 

 -- Ryan Schultz <schultz.ryan@gmail.com>  Thu,  1 Jun 2006 20:48:48 -0400

mednafen (0.6.0-1) unstable; urgency=low

  * New upstream version.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Tue, 16 May 2006 13:06:32 -0400

mednafen (0.5.2-1) unstable; urgency=low

  * New upstream version. Closes: #351586

 -- Ryan Schultz <schultz.ryan@gmail.com>  Tue, 16 May 2006 13:06:27 -0400

mednafen (0.4.7-1) unstable; urgency=low

  * New upstream version. Closes: #349845
  * Add Trio copyright info.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Thu,  2 Feb 2006 14:24:53 -0500

mednafen (0.4.5-1) unstable; urgency=low

  * New upstream version. Closes: #349633
  * Remove JACK and ESD dependencies.
  * Update description.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Tue, 24 Jan 2006 18:01:01 -0500

mednafen (0.4.4-1) unstable; urgency=low

  * New upstream version.
  * Add debian/watch file.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Sun, 22 Jan 2006 21:43:34 -0500

mednafen (0.4.1-1) unstable; urgency=low

  * New upstream release.
  * Fix some small packaging issues.
  * Expand debian/copyright file.

 -- Ryan Schultz <schultz.ryan@gmail.com>  Thu, 29 Dec 2005 17:43:00 -0500

mednafen (0.4.0-1) unstable; urgency=low

  * New upstream release. 

 -- Ryan Schultz <schultz.ryan@gmail.com>  Fri, 16 Dec 2005 15:10:58 -0500

mednafen (0.3.7-1) unstable; urgency=low

  * Initial release Closes: #340378
  * Upstream source repackaged to remove CVS dirs

 -- Ryan Schultz <schultz.ryan@gmail.com>  Tue, 22 Nov 2005 22:48:43 -0500

=== debian/control ===
Source: mednafen
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <steve@sk2.org>
Build-Depends: debhelper (>= 5), autotools-dev, x11proto-core-dev, libgl1-mesa-dev | libgl-dev, zlib1g-dev | libz-dev, libsdl1.2-dev, libsamplerate0-dev, libsdl-net1.2-dev, libcdio-dev, libsndfile1-dev | libsndfile-dev, libasound2-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386]
Standards-Version: 3.8.4
Homepage: http://mednafen.sourceforge.net
Vcs-Git: git://git.debian.org/git/pkg-games/mednafen.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/mednafen.git

Package: mednafen
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: nes-emulator
Description: multi-platform emulator, including NES, GB/A, Lynx, PC Engine
 Mednafen is a command-line driven emulator for many different systems. It 
 has full support for OpenGL and SDL graphics, network play, remappable input
 configuration, joystick and keyboard support, save states, game rewinding,
 GSF playback, and screenshots.
 .
 The systems supported by Mednafen are:
    * Atari Lynx
    * GameBoy
    * GameBoy Color
    * GameBoy Advance
    * NES
    * PC Engine (TurboGrafx 16)
    * PC-FX
    * SuperGrafx
    * NeoGeo Pocket, NeoGeo Pocket Color
    * WonderSwan
 .
 Hardware emulated by Mednafen includes:
    * NES gamepad, Zapper, PowerPad
    * Four-Score, Famicom multiplayer adapter
    * Arkanoid, HyperShot, Space Shadow, Mahjong controllers
    * Oeka Kids tablet, Quiz King buzzers, Family Trainer, Barcode World
    * Game Genie

## mednafen 0.8.D.3

=== debian/changelog ===
mednafen (0.8.D.3-6) unstable; urgency=low

  * Build using the provided libvorbisidec source; mednafen doesn't work
    correctly with the version currently in Debian (closes: #699143).

 -- Stephen Kitt <steve@sk2.org>  Tue, 29 Jan 2013 23:40:10 +0100

mednafen (0.8.D.3-5) unstable; urgency=low

  * Use ${source:Package} with dpkg-query to retrieve only the package
    name in the Built-Using field (closes: #677867).
  * Drop unused GPL-2 license paragraph from debian/copyright.
  * Fix configure.ac to ensure dpkg-buildflags' CPPFLAGS make it all the
    way through the build.

 -- Stephen Kitt <steve@sk2.org>  Mon, 18 Jun 2012 01:01:20 +0200

mednafen (0.8.D.3-4) unstable; urgency=low

  * Update debian/watch to track stable releases only.
  * Pull in relevant changes from the experimental package:
    - wrap-and-sort debian/control
    - add a Built-Using relationship to the package from which MiniLZO is
      copied
    - build using libvorbisidec-dev rather than the provided tremor source
    - switch to DEP-5 format for debian/copyright
    - add cheats.txt to the shipped documentation
    - build with dh-autoreconf
    - use debian/gbp.conf to enforce pristine-tar use
    - add README.source describing the source code replacements

 -- Stephen Kitt <steve@sk2.org>  Wed, 16 May 2012 22:50:02 +0200

mednafen (0.8.D.3-3) unstable; urgency=low

  * Build with zlib 1.2.6 and later (patch by Michał Ziąbkowski, adapted
    by Steven Chamberlain; closes: #661657).
  * Build-depend on debhelper 9.
  * Standards-Version 3.9.3, no change required.

 -- Stephen Kitt <steve@sk2.org>  Wed, 29 Feb 2012 23:28:31 +0100

mednafen (0.8.D.3-2) unstable; urgency=low

  [ Stephen Kitt ]
  * Fix "debian/control uses hardcoded list of non-Linux architectures" -
    qualify libasound2-dev dependency using [linux-any] instead of
    [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386] (closes: #634461).
  * Install .desktop file allowing file association, with known
    supported MIME types, as suggested by Damian Yarrick (LP: #886912;
    helps with #635538).
  * Simplify rules using dh 9 and enable hardening.
  * Build-conflict with autoconf2.13 which causes the build to fail.
  * Standards-Version 3.9.2, no change required beyond the above.

  [ Piotr Ożarowski ]
  * Set DM-Upload-Allowed flag to yes

 -- Stephen Kitt <steve@sk2.org>  Tue, 08 Nov 2011 07:20:54 +0100

mednafen (0.8.D.3-1) unstable; urgency=low

  * New upstream version, fixing a significant memory leak.

 -- Stephen Kitt <steve@sk2.org>  Fri, 17 Sep 2010 07:18:16 +0200

mednafen (0.8.D.2-1) unstable; urgency=low

  * New upstream version.
  * Standards-Version 3.9.1, no change required.
  * Add build dependency on libjack-dev.

 -- Stephen Kitt <steve@sk2.org>  Thu, 05 Aug 2010 08:35:19 +0200

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,35 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Stephen Kitt <steve@sk2.org>
-Build-Depends: debhelper (>= 5), autotools-dev, x11proto-core-dev, libgl1-mesa-dev | libgl-dev, zlib1g-dev | libz-dev, libsdl1.2-dev, libsamplerate0-dev, libsdl-net1.2-dev, libcdio-dev, libsndfile1-dev | libsndfile-dev, libasound2-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386]
-Standards-Version: 3.8.4
+Build-Depends: autotools-dev,
+               debhelper (>= 9),
+               dh-autoreconf,
+               libasound2-dev [linux-any],
+               libcdio-dev,
+               libgl1-mesa-dev | libgl-dev,
+               libjack-dev,
+               liblzo2-dev,
+               libsamplerate0-dev,
+               libsdl-net1.2-dev,
+               libsdl1.2-dev,
+               libsndfile1-dev | libsndfile-dev,
+               libvorbisidec-dev,
+               x11proto-core-dev,
+               zlib1g-dev | libz-dev
+Build-Conflicts: autoconf2.13
+Standards-Version: 3.9.3
 Homepage: http://mednafen.sourceforge.net
 Vcs-Git: git://git.debian.org/git/pkg-games/mednafen.git
 Vcs-Browser: http://git.debian.org/?p=pkg-games/mednafen.git
+DM-Upload-Allowed: yes
 
 Package: mednafen
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Provides: nes-emulator
+Built-Using: ${bu:liblzo2}
 Description: multi-platform emulator, including NES, GB/A, Lynx, PC Engine
- Mednafen is a command-line driven emulator for many different systems. It 
+ Mednafen is a command-line driven emulator for many different systems. It
  has full support for OpenGL and SDL graphics, network play, remappable input
  configuration, joystick and keyboard support, save states, game rewinding,
  GSF playback, and screenshots.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

liblzo2_source := $(shell dpkg-query -W -f='$${source:Package} (= $${source:Version})' liblzo2-dev)


%:
	dh $@ --with autoreconf

override_dh_auto_build:
	# Update MiniLZO
	cp src/compress/lzoconf.h src/compress/lzoconf.h.orig
	cp src/compress/lzodefs.h src/compress/lzodefs.h.orig
	cp src/compress/minilzo.c src/compress/minilzo.c.orig
	cp src/compress/minilzo.h src/compress/minilzo.h.orig
	cp /usr/share/lzo/minilzo/*.[ch] src/compress

	dh_auto_build

override_dh_auto_clean:
	# Restore MiniLZO
	[ ! -f src/compress/lzoconf.h.orig ] || mv src/compress/lzoconf.h.orig src/compress/lzoconf.h
	[ ! -f src/compress/lzodefs.h.orig ] || mv src/compress/lzodefs.h.orig src/compress/lzodefs.h
	[ ! -f src/compress/minilzo.c.orig ] || mv src/compress/minilzo.c.orig src/compress/minilzo.c
	[ ! -f src/compress/minilzo.h.orig ] || mv src/compress/minilzo.h.orig src/compress/minilzo.h

	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- --bindir=/usr/games

override_dh_gencontrol-arch:
	dh_gencontrol -a -- '-Vbu:liblzo2=$(liblzo2_source)'

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Track stable releases only
http://sf.net/mednafen/mednafen-(\d+\.\d*[02468]\..*)\.tar\.bz2

## mednafen 0.9.18

=== src/snes/src/Makefile ===
include lib/nall/Makefile
include lib/nall/Makefile-qt
ui = ui_qt

################
### compiler ###
################

c     := $(compiler)
cpp   := $(subst cc,++,$(compiler))
flags := -O3 -fomit-frame-pointer -Ilib
link  :=

# profile-guided instrumentation:
# flags += -fprofile-generate
# link += -lgcov

# profile-guided optimization:
# flags += -fprofile-use

################
### platform ###
################

ifeq ($(platform),x)
  link += -s

  ruby := video.glx video.xv video.qtraster video.sdl
  ruby += audio.alsa audio.openal audio.oss audio.pulseaudio audio.pulseaudiosimple audio.ao
  ruby += input.sdl input.x

  link += $(if $(findstring audio.openal,$(ruby)),-lopenal)
else ifeq ($(platform),osx)
  ruby := video.qtopengl video.qtraster
  ruby += audio.openal
  ruby += input.carbon

  link += $(if $(findstring audio.openal,$(ruby)),-framework OpenAL)
else ifeq ($(platform),win)
  link += -mwindows -mthreads
# link += -mconsole -mthreads
  link += -s -luuid -lkernel32 -luser32 -lgdi32 -lshell32
  # statically link Qt for Windows build
  link += -enable-stdcall-fixup -Wl,-enable-auto-import -Wl,-enable-runtime-pseudo-reloc

  ruby := video.direct3d video.wgl video.directdraw video.gdi video.qtraster
  ruby += audio.directsound
  ruby += input.rawinput input.directinput

  link += $(if $(findstring audio.openal,$(ruby)),-lopenal32)
else
  unknown_platform: help;
endif

############
### ruby ###
############

rubyflags := $(call ifhas,.sdl,$(ruby),`sdl-config --cflags`)
rubyflags += $(call ifhas,.qt,$(ruby),$(qtinc))

link += $(call ifhas,.sdl,$(ruby),`sdl-config --libs`)
link += $(call ifhas,video.direct3d,$(ruby),-ld3d9)
link += $(call ifhas,video.directdraw,$(ruby),-lddraw)
link += $(call ifhas,video.glx,$(ruby),-lGL)
link += $(call ifhas,video.wgl,$(ruby),-lopengl32)
link += $(call ifhas,video.xv,$(ruby),-lXv)
link += $(call ifhas,audio.alsa,$(ruby),-lasound)
link += $(call ifhas,audio.ao,$(ruby),-lao)
link += $(call ifhas,audio.directsound,$(ruby),-ldsound)
link += $(call ifhas,audio.pulseaudio,$(ruby),-lpulse-simple)
link += $(call ifhas,input.directinput,$(ruby),-ldinput8 -ldxguid)
link += $(call ifhas,input.rawinput,$(ruby),-ldinput8 -ldxguid)

###############
### objects ###
###############

objects := libco ruby
objects += system cartridge cheat
objects += memory smemory cpu cpucore scpu smp smpcore ssmp sdsp ppu bppu
objects += supergameboy superfx sa1
objects += bsx srtc sdd1 spc7110 cx4 dsp1 dsp2 dsp3 dsp4 obc1 st010 st011 st018
objects += 21fx

######################
### implicit rules ###
######################

compile = \
  $(strip \
    $(if $(filter %.c,$<), \
      $(c) $(flags) $1 -c $< -o $@, \
      $(if $(filter %.cpp,$<), \
        $(cpp) $(flags) $1 -c $< -o $@ \
      ) \
    ) \
  )

%.o: $<; $(call compile)

all: build;

include $(ui)/Makefile
objects := $(patsubst %,obj/%.o,$(objects))
rubydef := $(foreach c,$(subst .,_,$(call strupper,$(ruby))),-D$c)

#################
### libraries ###
#################

obj/ruby.o: lib/ruby/ruby.cpp $(call rwildcard,lib/ruby/*)
	$(call compile,$(rubydef) $(rubyflags))
obj/libco.o: lib/libco/libco.c lib/libco/*

#################
### utilities ###
#################

obj/cartridge.o: cartridge/cartridge.cpp cartridge/*
obj/cheat.o    : cheat/cheat.cpp cheat/*

##############
### memory ###
##############

obj/memory.o : memory/memory.cpp memory/*
obj/smemory.o: memory/smemory/smemory.cpp $(call rwildcard,memory/smemory/)

###########
### cpu ###
###########

obj/cpu.o    : cpu/cpu.cpp cpu/*
obj/cpucore.o: cpu/core/core.cpp $(call rwildcard,cpu/core/)
obj/scpu.o   : cpu/scpu/scpu.cpp $(call rwildcard,cpu/scpu/)

###########
### smp ###
###########

obj/smp.o    : smp/smp.cpp smp/*
obj/smpcore.o: smp/core/core.cpp $(call rwildcard,smp/core/)
obj/ssmp.o   : smp/ssmp/ssmp.cpp $(call rwildcard,smp/ssmp/)

###########
### dsp ###
###########

obj/adsp.o: dsp/adsp/adsp.cpp dsp/adsp/*
obj/sdsp.o: dsp/sdsp/sdsp.cpp dsp/sdsp/*

###########
### ppu ###
###########

obj/ppu.o : ppu/ppu.cpp ppu/*
obj/bppu.o: ppu/bppu/bppu.cpp $(call rwildcard,ppu/bppu/)

##############
### system ###
##############

obj/system.o: system/system.cpp $(call rwildcard,system/)

#####################
### special chips ###
#####################

obj/supergameboy.o: chip/supergameboy/supergameboy.cpp $(call rwildcard,chip/supergameboy/)
obj/superfx.o     : chip/superfx/superfx.cpp $(call rwildcard,chip/superfx/)
obj/sa1.o         : chip/sa1/sa1.cpp $(call rwildcard,chip/sa1/)
obj/bsx.o         : chip/bsx/bsx.cpp chip/bsx/*
obj/srtc.o        : chip/srtc/srtc.cpp chip/srtc/*
obj/sdd1.o        : chip/sdd1/sdd1.cpp chip/sdd1/*
obj/spc7110.o     : chip/spc7110/spc7110.cpp chip/spc7110/*
obj/cx4.o         : chip/cx4/cx4.cpp chip/cx4/*
obj/dsp1.o        : chip/dsp1/dsp1.cpp chip/dsp1/*
obj/dsp2.o        : chip/dsp2/dsp2.cpp chip/dsp2/*
obj/dsp3.o        : chip/dsp3/dsp3.cpp chip/dsp3/*
obj/dsp4.o        : chip/dsp4/dsp4.cpp chip/dsp4/*
obj/obc1.o        : chip/obc1/obc1.cpp chip/obc1/*
obj/st010.o       : chip/st010/st010.cpp chip/st010/*
obj/st011.o       : chip/st011/st011.cpp chip/st011/*
obj/st018.o       : chip/st018/st018.cpp chip/st018/*
obj/21fx.o        : chip/21fx/21fx.cpp chip/21fx/*

###############
### targets ###
###############

build: ui_build $(objects)
ifeq ($(platform),osx)
	test -d ../bsnes.app || mkdir -p ../bsnes.app/Contents/MacOS
	$(strip $(cpp) -o ../bsnes.app/Contents/MacOS/bsnes $(objects) $(link))
else
	$(strip $(cpp) -o ../bsnes $(objects) $(link))
endif

install:
	install -D -m 755 ../bsnes $(DESTDIR)$(prefix)/bin/bsnes
	install -D -m 644 data/bsnes.png $(DESTDIR)$(prefix)/share/pixmaps/bsnes.png
	install -D -m 644 data/bsnes.desktop $(DESTDIR)$(prefix)/share/applications/bsnes.desktop

clean: ui_clean
	-@$(call delete,obj/*.o)
	-@$(call delete,*.res)
	-@$(call delete,*.pgd)
	-@$(call delete,*.pgc)
	-@$(call delete,*.ilk)
	-@$(call delete,*.pdb)
	-@$(call delete,*.manifest)

help:
	@echo "Usage: $(MAKE) platform=(os) compiler=(cc) [options]"
	@echo ""
	@echo "Supported platforms:"
	@echo "  x   - Linux / BSD (x86, x86-64)"
	@echo "  win - Windows (x86, x86-64)"
	@echo ""
	@echo "Supported compilers:"
	@echo "  gcc              - GCC compiler"
	@echo "  mingw32-gcc      - MinGW compiler"
	@echo "  i586-mingw32-gcc - MinGW cross compiler"
	@echo ""
	@echo "Example: $(MAKE) platform=x compiler=gcc"
	@echo ""

=== src/snes/src/ui_qt/Makefile ===
objects := ui-main ui-base ui-cartridge ui-debugger ui-input ui-movie ui-settings ui-state ui-tools $(objects)
objects += $(if $(call streq,$(platform),win),resource)
link += $(qtlib)

headers := $(call rwildcard,$(ui)/,%.hpp)
moc_headers := $(call rwildcard,$(ui)/,%.moc.hpp)
moc_objects := $(foreach f,$(moc_headers),obj/$(notdir $(patsubst %.moc.hpp,%.moc,$f)))
qt_compile = $(call compile,-Iobj $(qtinc))

#############
### rules ###
#############

# automatically run moc on all .moc.hpp (MOC header) files
%.moc: $<; $(moc) -i $< -o $@

# automatically generate %.moc build rules
__list = $(moc_headers)
$(foreach f,$(moc_objects), \
  $(eval __file = $(word 1,$(__list))) \
  $(eval __list = $(wordlist 2,$(words $(__list)),$(__list))) \
  $(eval $f: $(__file)) \
)

obj/ui-main.o: $(ui)/main.cpp $(headers) $(wildcard $(ui)/*.cpp) $(wildcard $(ui)/platform/*.cpp) $(wildcard $(ui)/utility/*.cpp); $(qt_compile)
obj/ui-base.o: $(ui)/base/base.cpp $(headers) $(wildcard $(ui)/base/*.cpp); $(qt_compile)
obj/ui-cartridge.o: $(ui)/cartridge/cartridge.cpp $(headers) $(wildcard $(ui)/cartridge/*.cpp); $(qt_compile)
obj/ui-debugger.o: $(ui)/debugger/debugger.cpp $(headers) $(call rwildcard,$(ui)/debugger/,%.cpp); $(qt_compile)
obj/ui-input.o: $(ui)/input/input.cpp $(headers) $(wildcard $(ui)/input/*.cpp); $(qt_compile)
obj/ui-movie.o: $(ui)/movie/movie.cpp $(headers) $(wildcard $(ui)/movie/*.cpp); $(qt_compile)
obj/ui-settings.o: $(ui)/settings/settings.cpp $(headers) $(wildcard $(ui)/settings/*.cpp); $(qt_compile)
obj/ui-state.o: $(ui)/state/state.cpp $(headers) $(wildcard $(ui)/state/*.cpp); $(qt_compile)
obj/ui-tools.o: $(ui)/tools/tools.cpp $(headers) $(wildcard $(ui)/tools/*.cpp); $(qt_compile)

obj/resource.rcc: $(ui)/resource/resource.qrc data/*
	$(rcc) $(ui)/resource/resource.qrc -o obj/resource.rcc

obj/resource.o: $(ui)/resource/resource.rc
	windres $(ui)/resource/resource.rc obj/resource.o

###############
### targets ###
###############

ui_build: obj/resource.rcc $(moc_objects);
ui_clean:
	-@$(call delete,obj/*.rcc)
	-@$(call delete,obj/*.moc)

=== debian/changelog ===
mednafen (0.9.18-1) experimental; urgency=low

  * New upstream WIP version, adding PSX emulation (only on little-endian
    systems).
  * Update copyright information.
  * Refresh use-system-tremor.patch and use dh-autoreconf to handle all
    the autotools reconfiguration involved.
  * Fix "debian/control uses hardcoded list of non-Linux architectures" -
    qualify libasound2-dev dependency using [linux-any] instead of
    [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386] (closes: #634461).
  * Install .desktop file allowing file association, with known
    supported MIME types, as suggested by Damian Yarrick (LP: #886912;
    helps with #635538).
  * Simplify rules using dh 9 and enable hardening.
  * Build-conflict with autoconf2.13 which causes the build to fail.
  * Set DM-Upload-Allowed flag, as done by Piotr Ożarowski in 0.8.D.3-2.

 -- Stephen Kitt <steve@sk2.org>  Sat, 12 Nov 2011 01:15:38 +0100

mednafen (0.9.17.1-1) experimental; urgency=low

  * New upstream WIP version (closes: #614263), adding emulators for Sega
    Genesis / Mega Drive, Virtual Boy, and Super Nintendo Entertainment
    System.
  * Use external libvorbisidec instead of the bundled copy.
  * Use external minilzo instead of the bundled copy.
  * Standards-Version 3.9.2, no change required.

 -- Stephen Kitt <steve@sk2.org>  Wed, 13 Apr 2011 22:33:57 +0200

=== debian/control ===
Source: mednafen
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <steve@sk2.org>
Build-Depends: debhelper (>= 8.1.3), dh-autoreconf, autotools-dev, x11proto-core-dev,
 libgl1-mesa-dev | libgl-dev, zlib1g-dev | libz-dev, libsdl1.2-dev,
 libsamplerate0-dev, libsdl-net1.2-dev, libcdio-dev,
 libsndfile1-dev | libsndfile-dev,
 libasound2-dev [linux-any],
 libjack-dev,
 libvorbisidec-dev,
 liblzo2-dev
Build-Conflicts: autoconf2.13
Standards-Version: 3.9.2
Homepage: http://mednafen.sourceforge.net
Vcs-Git: git://git.debian.org/git/pkg-games/mednafen.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/mednafen.git
DM-Upload-Allowed: yes

Package: mednafen
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: nes-emulator
Description: multi-platform emulator, including NES, GB/A, Lynx, PC Engine
 Mednafen is a command-line driven emulator for many different systems. It 
 has full support for OpenGL and SDL graphics, network play, remappable input
 configuration, joystick and keyboard support, save states, game rewinding,
 GSF playback, and screenshots.
 .
 This is the "work in progress" version; in particular, there is no
 guarantee that save states will work from one version to the next.
 .
 The systems supported by Mednafen are:
    * Atari Lynx
    * GameBoy
    * GameBoy Color
    * GameBoy Advance
    * NES
    * SNES
    * Virtual Boy
    * PC Engine (TurboGrafx 16)
    * PC-FX
    * SuperGrafx
    * NeoGeo Pocket, NeoGeo Pocket Color
    * WonderSwan
    * Sega Genesis / Mega Drive
    * Sony PlayStation (experimental)
 .
 Hardware emulated by Mednafen includes:
    * NES gamepad, Zapper, PowerPad
    * Four-Score, Famicom multiplayer adapter
    * Arkanoid, HyperShot, Space Shadow, Mahjong controllers
    * Oeka Kids tablet, Quiz King buzzers, Family Trainer, Barcode World
    * Game Genie

## mednafen 0.9.19

=== debian/changelog ===
mednafen (0.9.19-2) experimental; urgency=low

  * Build with zlib 1.2.6 and later (patch by Michał Ziąbkowski).
  * Fix interpolation shaders (patch by "Valfar").

 -- Stephen Kitt <steve@sk2.org>  Mon, 20 Feb 2012 06:52:07 +0100

mednafen (0.9.19-1) experimental; urgency=low

  * New upstream WIP version.
  * Update copyright information.
  * Refresh use-system-tremor.patch and remove psx-big-endian-only.patch.
  * Add spelling-fixes.patch based on Lintian's recommendations.
  * Build-depend on debhelper 9 or later and remove corresponding Lintian
    override.

 -- Stephen Kitt <steve@sk2.org>  Tue, 31 Jan 2012 07:21:35 +0100

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,6 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-
-liblzo2_source := $(shell dpkg-query -W -f='$${source:Package} (= $${source:Version})' liblzo2-dev)
-
 
 %:
 	dh $@ --with autoreconf
@@ -30,7 +27,4 @@
 	dh_auto_clean
 
 override_dh_auto_configure:
-	dh_auto_configure -- --bindir=/usr/games
-
-override_dh_gencontrol-arch:
-	dh_gencontrol -a -- '-Vbu:liblzo2=$(liblzo2_source)'
+	dh_auto_configure -- --bindir=/usr/games --enable-psx

## mednafen 0.9.33.3

=== src/snes_perf/src/Makefile ===
include nall/Makefile
snes := snes
profile := performance

fpic = -fPIC
extraflags = -O3 -fomit-frame-pointer -I. -I$(snes) $(fpic)

# profile-guided instrumentation. Compile your frontend with this as well. :)
# extraflags += -fprofile-generate --coverage

# profile-guided optimization
# extraflags += -fprofile-use

# implicit rules
compile = \
  $(strip \
    $(if $(filter %.c,$<), \
      $(CC) $(CFLAGS) $(extraflags) $1 -c $< -o $@, \
      $(if $(filter %.cpp,$<), \
        $(CXX) $(CXXFLAGS) $(extraflags) $1 -c $< -o $@ \
      ) \
    ) \
  )

all: library;

set-static:
	$(eval fpic := )

static: set-static static-library;

install: library-install;

uninstall: library-uninstall;

%.o: $<; $(call compile)
include $(snes)/Makefile

clean: 
	-@$(call delete,obj/*.o)
	-@$(call delete,obj/*.a)
	-@$(call delete,obj/*.so)
	-@$(call delete,obj/*.dylib)
	-@$(call delete,obj/*.dll)
	-@$(call delete,out/*.a)
	-@$(call delete,out/*.so)
	-@$(call delete,*.res)
	-@$(call delete,*.pgd)
	-@$(call delete,*.pgc)
	-@$(call delete,*.ilk)
	-@$(call delete,*.pdb)
	-@$(call delete,*.manifest)

archive-all:
	tar -cjf libsnes.tar.bz2 libco nall obj out snes Makefile cc.bat clean.bat sync.sh

help:;

=== src/snes_perf/src/nall/Makefile ===
# Makefile
# author: byuu
# license: public domain

[A-Z] = A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
[a-z] = a b c d e f g h i j k l m n o p q r s t u v w x y z
[0-9] = 0 1 2 3 4 5 6 7 8 9
[markup] = ` ~ ! @ \# $$ % ^ & * ( ) - _ = + [ { ] } \ | ; : ' " , < . > / ?
[all] = $([A-Z]) $([a-z]) $([0-9]) $([markup])
[space] :=
[space] +=

#####
# platform detection
#####

ifeq ($(platform),)
  uname := $(shell uname -a)
  ifeq ($(uname),)
    platform := win
    delete = del $(subst /,\,$1)
  else ifneq ($(findstring Darwin,$(uname)),)
    platform := osx
    delete = rm -f $1
  else
    platform := x
    delete = rm -f $1
  endif
endif

ifeq ($(prefix),)
  prefix := /usr/local
endif

#####
# function rwildcard(directory, pattern)
#####
rwildcard = \
  $(strip \
    $(filter $(if $2,$2,%), \
      $(foreach f, \
        $(wildcard $1*), \
        $(eval t = $(call rwildcard,$f/)) \
        $(if $t,$t,$f) \
      ) \
    ) \
  )

#####
# function strtr(source, from, to)
#####
strtr = \
  $(eval __temp := $1) \
  $(strip \
    $(foreach c, \
      $(join $(addsuffix :,$2),$3), \
      $(eval __temp := \
        $(subst $(word 1,$(subst :, ,$c)),$(word 2,$(subst :, ,$c)),$(__temp)) \
      ) \
    ) \
    $(__temp) \
  )

#####
# function strupper(source)
#####
strupper = $(call strtr,$1,$([a-z]),$([A-Z]))

#####
# function strlower(source)
#####
strlower = $(call strtr,$1,$([A-Z]),$([a-z]))

#####
# function strlen(source)
#####
strlen = \
  $(eval __temp := $(subst $([space]),_,$1)) \
  $(words \
    $(strip \
      $(foreach c, \
        $([all]), \
        $(eval __temp := \
          $(subst $c,$c ,$(__temp)) \
        ) \
      ) \
      $(__temp) \
    ) \
  )

#####
# function streq(source)
#####
streq = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),,1)

#####
# function strne(source)
#####
strne = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),1,)

=== src/snes_perf/src/snes/Makefile ===
snes_objects := libco
snes_objects += snes-system
snes_objects += snes-cartridge snes-cheat
snes_objects += snes-memory snes-cpucore snes-smpcore
snes_objects += snes-cpu snes-smp snes-dsp snes-ppu
snes_objects += snes-supergameboy snes-superfx snes-sa1 snes-upd77c25
snes_objects += snes-bsx snes-srtc snes-sdd1 snes-spc7110 snes-cx4
snes_objects += snes-obc1 snes-st0010 snes-st0011 snes-st0018
snes_objects += snes-msu1 snes-serial
objects += $(snes_objects)

ifeq ($(profile),accuracy)
  extraflags += -DPROFILE_ACCURACY
  snescpu := $(snes)/cpu
  snessmp := $(snes)/smp
  snesdsp := $(snes)/dsp
  snesppu := $(snes)/ppu
else ifeq ($(profile),compatibility)
  extraflags += -DPROFILE_COMPATIBILITY
  snescpu := $(snes)/cpu
  snessmp := $(snes)/smp
  snesdsp := $(snes)/alt/dsp
  snesppu := $(snes)/alt/ppu-compatibility
else ifeq ($(profile),performance)
  extraflags += -DPROFILE_PERFORMANCE
  snescpu := $(snes)/alt/cpu
  snessmp := $(snes)/smp
  snesdsp := $(snes)/alt/dsp
  snesppu := $(snes)/alt/ppu-performance
endif

obj/libco.o  : libco/libco.c libco/*
obj/libsnes.o: $(snes)/libsnes/libsnes.cpp $(snes)/libsnes/*

obj/snes-system.o   : $(snes)/system/system.cpp $(call rwildcard,$(snes)/system/) $(call rwildcard,$(snes)/video/)
obj/snes-memory.o   : $(snes)/memory/memory.cpp $(call rwildcard,$(snes)/memory/)
obj/snes-cpucore.o  : $(snes)/cpu/core/core.cpp $(call rwildcard,$(snes)/cpu/core/)
obj/snes-smpcore.o  : $(snes)/smp/core/core.cpp $(call rwildcard,$(snes)/smp/core/)
obj/snes-cpu.o      : $(snescpu)/cpu.cpp $(call rwildcard,$(snescpu)/)
obj/snes-smp.o      : $(snessmp)/smp.cpp $(call rwildcard,$(snessmp)/)
obj/snes-dsp.o      : $(snesdsp)/dsp.cpp $(call rwildcard,$(snesdsp)/)
obj/snes-ppu.o      : $(snesppu)/ppu.cpp $(call rwildcard,$(snesppu)/)
obj/snes-cartridge.o: $(snes)/cartridge/cartridge.cpp $(call rwilddcard,$(snes)/cartridge/)
obj/snes-cheat.o    : $(snes)/cheat/cheat.cpp $(call rwildcard,$(snes)/cheat/)

obj/snes-supergameboy.o: $(snes)/chip/supergameboy/supergameboy.cpp $(call rwildcard,$(snes)/chip/supergameboy/)
obj/snes-superfx.o     : $(snes)/chip/superfx/superfx.cpp $(call rwildcard,$(snes)/chip/superfx/)
obj/snes-sa1.o         : $(snes)/chip/sa1/sa1.cpp $(call rwildcard,$(snes)/chip/sa1/)
obj/snes-upd77c25.o    : $(snes)/chip/upd77c25/upd77c25.cpp $(call rwildcard,$(snes)/chip/upd77c25/)
obj/snes-bsx.o         : $(snes)/chip/bsx/bsx.cpp $(snes)/chip/bsx/*
obj/snes-srtc.o        : $(snes)/chip/srtc/srtc.cpp $(snes)/chip/srtc/*
obj/snes-sdd1.o        : $(snes)/chip/sdd1/sdd1.cpp $(snes)/chip/sdd1/*
obj/snes-spc7110.o     : $(snes)/chip/spc7110/spc7110.cpp $(snes)/chip/spc7110/*
obj/snes-cx4.o         : $(snes)/chip/cx4/cx4.cpp $(snes)/chip/cx4/*
obj/snes-obc1.o        : $(snes)/chip/obc1/obc1.cpp $(snes)/chip/obc1/*
obj/snes-st0010.o      : $(snes)/chip/st0010/st0010.cpp $(snes)/chip/st0010/*
obj/snes-st0011.o      : $(snes)/chip/st0011/st0011.cpp $(snes)/chip/st0011/*
obj/snes-st0018.o      : $(snes)/chip/st0018/st0018.cpp $(snes)/chip/st0018/*
obj/snes-msu1.o        : $(snes)/chip/msu1/msu1.cpp $(snes)/chip/msu1/*
obj/snes-serial.o      : $(snes)/chip/serial/serial.cpp $(snes)/chip/serial/*

###########
# library #
###########

snes_objects := $(patsubst %,obj/%.o,$(snes_objects))

static-library: $(snes_objects) obj/libsnes.o
	ar rcs out/libsnes.a $(snes_objects) obj/libsnes.o

library: $(snes_objects) obj/libsnes.o
ifeq ($(platform),x)
	ar rcs out/libsnes.a $(snes_objects) obj/libsnes.o
	$(CXX) -o out/libsnes.so -fPIC -shared -Wl,-soname,libsnes.so.1 $(snes_objects) obj/libsnes.o
else ifeq ($(platform),osx)
	ar rcs out/libsnes.a $(snes_objects) obj/libsnes.o
	$(CXX) -o out/libsnes.dylib -install_name @executable_path/../Libraries/libsnes.dylib -shared -dynamiclib $(snes_objects) obj/libsnes.o
else ifeq ($(platform),win)
	$(CXX) -o out/snes.dll -shared -Wl,--out-implib,libsnes.a $(snes_objects) obj/libsnes.o
endif

library-install:
ifeq ($(platform),x)
	install -D -m 755 out/libsnes.a $(DESTDIR)$(prefix)/lib/libsnes.a
	install -D -m 755 out/libsnes.so $(DESTDIR)$(prefix)/lib/libsnes.so
	install -D -m 644 snes/libsnes/libsnes.hpp $(DESTDIR)$(prefix)/include/libsnes.hpp
	ldconfig -n $(DESTDIR)$(prefix)/lib
else ifeq ($(platform),osx)
	cp out/libsnes.dylib /usr/local/lib/libsnes.dylib
endif

library-uninstall:
ifeq ($(platform),x)
	rm $(DESTDIR)$(prefix)/lib/libsnes.a
	rm $(DESTDIR)$(prefix)/lib/libsnes.so
else ifeq ($(platform),osx)
	rm /usr/local/lib/libsnes.dylib
endif

=== debian/changelog ===
mednafen (0.9.33.3-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Tue, 22 Apr 2014 23:51:55 +0200

mednafen (0.9.33.2-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Tue, 25 Mar 2014 23:48:28 +0100

mednafen (0.9.33.1-1) unstable; urgency=medium

  * New upstream release.
  * Update priority to match override.
  * Update description since this is not an experimental release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 22 Mar 2014 13:05:47 +0100

mednafen (0.9.32.1-wip-1) experimental; urgency=low

  * New upstream WIP release.
  * Standards-Version 3.9.5, no change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 29 Nov 2013 23:38:53 +0100

mednafen (0.9.32-wip-1) experimental; urgency=low

  * New upstream WIP version.

 -- Stephen Kitt <skitt@debian.org>  Sat, 14 Sep 2013 00:14:39 +0200

mednafen (0.9.29-wip-1) experimental; urgency=low

  * New upstream WIP version. Follow upstream naming scheme strictly;
    thanks to Bart Martens for the discussion concerning this.
  * New watch file provided by Bart.
  * Switch to my Debian address.
  * Use canonical VCS URIs.
  * Standards-Version 3.9.4, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Thu, 22 Aug 2013 22:52:47 +0200

mednafen (0.9.28-1) experimental; urgency=low

  * New upstream WIP version.
  * Update debian/copyright for new SABR shader.

 -- Stephen Kitt <steve@sk2.org>  Mon, 21 Jan 2013 06:54:11 +0100

mednafen (0.9.27-1) experimental; urgency=low

  * New upstream WIP version.

 -- Stephen Kitt <steve@sk2.org>  Sat, 22 Dec 2012 15:29:44 +0100

mednafen (0.9.26-1) experimental; urgency=low

  * New upstream WIP version.
  * Change priority to "extra" to match libvorbisidec1's.
  * Drop "DM-Upload-Allowed" since it is no longer appropriate.
  * Refresh patches, replacing MPC_STATUS_FAIL constant from older mpcdec
    versions.

 -- Stephen Kitt <steve@sk2.org>  Mon, 19 Nov 2012 07:00:37 +0100

mednafen (0.9.24-1) experimental; urgency=low

  * New upstream WIP version.
  * Remove sdl-net build-dependency (no longer used).

 -- Stephen Kitt <steve@sk2.org>  Sat, 14 Jul 2012 15:23:08 +0200

mednafen (0.9.22-2) experimental; urgency=low

  * Use ${source:Package} with dpkg-query to retrieve only the package
    name in the Built-Using field (closes: #677867).

 -- Stephen Kitt <steve@sk2.org>  Mon, 18 Jun 2012 06:52:11 +0200

mednafen (0.9.22-1) experimental; urgency=low

  * New upstream WIP version (breaks Genesis/Megadrive save games).
  * Drop hardening-fixes.patch and cdromif-memset-fix.patch, merged
    upstream.

 -- Stephen Kitt <steve@sk2.org>  Wed, 30 May 2012 07:42:07 +0200

mednafen (0.9.21-2) experimental; urgency=low

  * Add a Built-Using relationship on the package MiniLZO was copied
    from.
  * Move away mpcdec and tremor at build time rather than through
    patches (this makes maintaining the patches easier).
  * Update README.source to indicate that mpcdec is now replaced as well
    as tremor.
  * Track upstream WIP versions published on sourceforge.net.

 -- Stephen Kitt <steve@sk2.org>  Wed, 16 May 2012 20:42:34 +0200

mednafen (0.9.21-1) experimental; urgency=low

  * New upstream WIP version.
  * Refresh use-system-tremor.patch and remove spelling-fixes.patch,
    gzip-1.2.6-fix.patch and shader-fix.patch (applied upstream).
  * Add use-system-mpcdec.patch to build using the Debian-provided
    libmpcdec rather than the bundled version.
  * Add cdrom-if-memset-fix.patch to fix an incorrect memset invocation
    (spotted by gcc).
  * Standard-Version 3.9.3, no change required.
  * wrap-and-sort control files.

 -- Stephen Kitt <steve@sk2.org>  Tue, 03 Apr 2012 00:05:58 +0200

=== debian/control ===
Source: mednafen
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <skitt@debian.org>
Build-Depends: autotools-dev,
               debhelper (>= 9),
               dh-autoreconf,
               libasound2-dev [linux-any],
               libcdio-dev,
               libgl1-mesa-dev | libgl-dev,
               libjack-dev,
               liblzo2-dev,
               libmpcdec-dev,
               libsamplerate0-dev,
               libsdl1.2-dev,
               libsndfile1-dev | libsndfile-dev,
               libvorbisidec-dev,
               x11proto-core-dev,
               zlib1g-dev | libz-dev
Build-Conflicts: autoconf2.13
Standards-Version: 3.9.5
Homepage: http://mednafen.sourceforge.net
Vcs-Git: git://anonscm.debian.org/pkg-games/mednafen.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/mednafen.git

Package: mednafen
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: nes-emulator
Built-Using: ${bu:liblzo2}
Description: multi-platform emulator, including NES, GB/A, Lynx, PC Engine
 Mednafen is a command-line driven emulator for many different systems. It
 has full support for OpenGL and SDL graphics, network play, remappable input
 configuration, joystick and keyboard support, save states, game rewinding,
 GSF playback, and screenshots.
 .
 The systems supported by Mednafen are:
    * Atari Lynx
    * GameBoy
    * GameBoy Color
    * GameBoy Advance
    * NES
    * SNES
    * Virtual Boy
    * PC Engine (TurboGrafx 16)
    * PC-FX
    * SuperGrafx
    * NeoGeo Pocket, NeoGeo Pocket Color
    * WonderSwan
    * Sega Genesis / Mega Drive
    * Sony PlayStation
 .
 Hardware emulated by Mednafen includes:
    * NES gamepad, Zapper, PowerPad
    * Four-Score, Famicom multiplayer adapter
    * Arkanoid, HyperShot, Space Shadow, Mahjong controllers
    * Oeka Kids tablet, Quiz King buzzers, Family Trainer, Barcode World
    * Game Genie

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,9 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+liblzo2_source := $(shell dpkg-query -W -f='$${source:Package} (= $${source:Version})' liblzo2-dev)
+
 
 %:
 	dh $@ --with autoreconf
@@ -15,6 +18,10 @@
 	cp src/compress/minilzo.h src/compress/minilzo.h.orig
 	cp /usr/share/lzo/minilzo/*.[ch] src/compress
 
+	# Move bundled source code for external packages out of the way
+	mv src/mpcdec src/mpcdec.orig
+	mv src/tremor src/tremor.orig
+
 	dh_auto_build
 
 override_dh_auto_clean:
@@ -24,7 +31,14 @@
 	[ ! -f src/compress/minilzo.c.orig ] || mv src/compress/minilzo.c.orig src/compress/minilzo.c
 	[ ! -f src/compress/minilzo.h.orig ] || mv src/compress/minilzo.h.orig src/compress/minilzo.h
 
+	# Restore bundled source code
+	[ ! -d src/mpcdec.orig ] || mv src/mpcdec.orig src/mpcdec
+	[ ! -d src/tremor.orig ] || mv src/tremor.orig src/tremor
+
 	dh_auto_clean
 
 override_dh_auto_configure:
 	dh_auto_configure -- --bindir=/usr/games --enable-psx
+
+override_dh_gencontrol-arch:
+	dh_gencontrol -a -- '-Vbu:liblzo2=$(liblzo2_source)'

## mednafen 0.9.36.4

=== src/snes/src/lib/nall/Makefile ===
# Makefile
# author: byuu
# license: public domain

[A-Z] = A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
[a-z] = a b c d e f g h i j k l m n o p q r s t u v w x y z
[0-9] = 0 1 2 3 4 5 6 7 8 9
[markup] = ` ~ ! @ \# $$ % ^ & * ( ) - _ = + [ { ] } \ | ; : ' " , < . > / ?
[all] = $([A-Z]) $([a-z]) $([0-9]) $([markup])
[space] :=
[space] +=

#####
# platform detection
#####

ifeq ($(platform),)
  uname := $(shell uname -a)
  ifeq ($(uname),)
    platform := win
    delete = del $(subst /,\,$1)
  else ifneq ($(findstring Darwin,$(uname)),)
    platform := osx
    delete = rm -f $1
  else
    platform := x
    delete = rm -f $1
  endif
endif

ifeq ($(compiler),)
  compiler := gcc
endif

ifeq ($(prefix),)
  prefix := /usr/local
endif

#####
# function rwildcard(directory, pattern)
#####
rwildcard = \
  $(strip \
    $(filter $(if $2,$2,%), \
      $(foreach f, \
        $(wildcard $1*), \
        $(eval t = $(call rwildcard,$f/)) \
        $(if $t,$t,$f) \
      ) \
    ) \
  )

#####
# function strtr(source, from, to)
#####
strtr = \
  $(eval __temp := $1) \
  $(strip \
    $(foreach c, \
      $(join $(addsuffix :,$2),$3), \
      $(eval __temp := \
        $(subst $(word 1,$(subst :, ,$c)),$(word 2,$(subst :, ,$c)),$(__temp)) \
      ) \
    ) \
    $(__temp) \
  )

#####
# function strupper(source)
#####
strupper = $(call strtr,$1,$([a-z]),$([A-Z]))

#####
# function strlower(source)
#####
strlower = $(call strtr,$1,$([A-Z]),$([a-z]))

#####
# function strlen(source)
#####
strlen = \
  $(eval __temp := $(subst $([space]),_,$1)) \
  $(words \
    $(strip \
      $(foreach c, \
        $([all]), \
        $(eval __temp := \
          $(subst $c,$c ,$(__temp)) \
        ) \
      ) \
      $(__temp) \
    ) \
  )

#####
# function streq(source)
#####
streq = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),,1)

#####
# function strne(source)
#####
strne = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),1,)

#####
# function ifhas(needle, haystack, true, false)
#####
ifhas = $(if $(findstring $1,$2),$3,$4)

=== debian/changelog ===
mednafen (0.9.36.4-1) unstable; urgency=medium

  * New upstream release.
  * Update licensing information.

 -- Stephen Kitt <skitt@debian.org>  Mon, 15 Sep 2014 23:34:04 +0200

mednafen (0.9.36.3-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Mon, 04 Aug 2014 23:55:28 +0200

mednafen (0.9.36.2-2) unstable; urgency=medium

  * libvorbisidec and libtrio are priority extra, so mednafen must be
    priority extra.
  * Build-depend on libtrio-dev 1.16 or later since that's the first
    version to build on all architectures (closes: #754709).
  * Enable parallel builds.
  * Move trio source out of the way during the build, as done for mpcdec
    and tremor.

 -- Stephen Kitt <skitt@debian.org>  Thu, 17 Jul 2014 21:00:53 +0200

mednafen (0.9.36.2-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 02 Jul 2014 15:09:09 +0200

mednafen (0.9.35.1-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 07 Jun 2014 15:55:03 +0200

mednafen (0.9.34.1-2) unstable; urgency=medium

  * Link trio with libm to hopefully build on Ubuntu.

 -- Stephen Kitt <skitt@debian.org>  Sun, 18 May 2014 22:37:51 +0200

mednafen (0.9.34.1-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 17 May 2014 21:36:36 +0200

mednafen (0.9.33.3-2) unstable; urgency=medium

  * Build using packaged libtrio (closes: #746817).

 -- Stephen Kitt <skitt@debian.org>  Sun, 04 May 2014 14:33:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: mednafen
 Section: games
-Priority: optional
+Priority: extra
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Stephen Kitt <skitt@debian.org>
 Build-Depends: autotools-dev,
@@ -15,6 +15,7 @@
                libsamplerate0-dev,
                libsdl1.2-dev,
                libsndfile1-dev | libsndfile-dev,
+               libtrio-dev (>= 1.16),
                libvorbisidec-dev,
                x11proto-core-dev,
                zlib1g-dev | libz-dev

=== debian/watch ===
version=3
http://qa.debian.org/watch/sf.php/mednafen/mednafen[_\-](\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## mednafen 0.9.38.4+dfsg

=== debian/changelog ===
mednafen (0.9.38.4+dfsg-2) unstable; urgency=medium

  * Move to optional to match the overrides.
  * Correct debian/copyright.
  * Upload to unstable.

 -- Stephen Kitt <skitt@debian.org>  Thu, 07 May 2015 19:49:37 +0200

mednafen (0.9.38.4+dfsg-1) experimental; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 15 Apr 2015 20:45:24 +0200

mednafen (0.9.38.3+dfsg-1) experimental; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Mon, 09 Mar 2015 23:42:18 +0100

mednafen (0.9.38.2+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Exclude PlayStation executables.

 -- Stephen Kitt <skitt@debian.org>  Sun, 22 Feb 2015 20:31:54 +0100

mednafen (0.9.38.1-1) experimental; urgency=medium

  * New upstream release.
  * Help make the build reproducible by dropping __DATE__ and __TIME__.
  * mednafen no longer uses libcdio, drop the build-dependency.

 -- Stephen Kitt <skitt@debian.org>  Mon, 16 Feb 2015 08:29:23 +0100

mednafen (0.9.37.1-1) experimental; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Thu, 25 Dec 2014 20:04:27 +0100

mednafen (0.9.36.5-1) experimental; urgency=medium

  * New upstream release, uploaded to expermiental for the Jessie freeze.
  * Standards-Version 3.9.6, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 08 Nov 2014 11:36:07 +0100
